import os
import requests
import json
import io
import base64
from PIL import Image
import openai
import logging

logging.basicConfig(level=logging.INFO, format='%(asctime)s - %(levelname)s - %(message)s')
logger = logging.getLogger(__name__)

file_handler = logging.FileHandler('script_log.txt')
logger.addHandler(file_handler)

masterPrompt = "(Masterpiece, best quality, solo:1.3), solo focus, upper body"
yorForgerPrompt = "1girl, yor briar, red sweater, (red dress:0.8), red eyes, white headband, earrings, <lora:yorForgerV3:0.8>, short hair with long locks, sidelocks, black hair, (long skirt:0.7)" 
yorForgerNegativePrompt = "multiple hair color"
negative_prompt = "lowres, low quality, worst quality, bad quality, bad-hands-5, realistic, nsfw, sexually suggestive, (breasts, cleavage:1.5), panel, manga, 3koma, 4koma, thigh, thighhigh, short skirt, on bed, bed, simple background, deformed, mutation"
negative_prompt = negative_prompt + yorForgerNegativePrompt

#Nanti coba ganti dengan History untuk mendapatkan history 5 chat
data_list = [
    {"message": "Success", "data": "O-oh? S-selamat datang di gedung ini, D-dokter NekoFi! Aku Yor Forger, semoga kita bisa menjadi tetangga yang baik. Inner Thought 🌷: Apa dia sudah mengetahui identitasku? Atau mungkin ini hanya kebetulan belaka... Haruskah aku berhati-hati terhadap pria ini?"},
    {"message": "Success", "data": "Hehe, kurasa begitu. A-aku tinggal bersama adikku, Yuri Briar. Dia sedang bekerja sekarang sih. Inner Thought 🌷: Kukira dia akan mengajukan pertanyaan yang lebih sulit...apakah ini hanya trik atau emang segitu doank?"},
    {"message": "Success", "data": "Ohh... Terimakasih banyak, NekoFi-san! A-aku senang sekali kau berinisiatif untuk membawakan ini. K-kami pasti akan menikmatinya Inner Thought 🌷: Apakah dia mencoba meracuniku? Sebaiknya aku periksa dulu sebelum memakannya."},
    {"message": "Success", "data": "T-terimakasih banyak, Dr. NekoFi! S-saya berharap saya tidak perlu mengambil tawaran itu terlalu sering, haha... Inner Thought 🌷: Diskon? Apakah ini cara lain untuk meracuniku? Perlu diwaspadai..."},
    {"message": "Success", "data": "O-Oke, sampai jumpa lagi, Dr. NekoFi! Terimakasih sudah berkunjung dan membawakan kue! :) Inner Thought 🌷: Orang itu pasti mencurigakan. Aku perlu melakukan pengecekan lebih lanjut malam ini."}
]

chat_text = "\n".join([f"Chat{i+1}: \"{item['data']}\"" for i, item in enumerate(data_list)])
logger.info("Chat text concatenated.")

openai.api_key = "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"
prompt_text = (
    f"Describe Yor Forger's physical actions and expressions in a single sentence, focusing solely on her without mentioning other characters or specific place names, suitable for a Text to Image AI prompt, and without referencing her thoughts or spoken words. Describe about her place too"
    f"\n\n{chat_text}"
)

logger.info("Sending prompt to OpenAI API...")
response_openai = openai.Completion.create(
    model="gpt-3.5-turbo-instruct",
    prompt=prompt_text,
    max_tokens=300,
    temperature=0.7
)
logger.info("Received response from OpenAI API.")

response_text = response_openai['choices'][0]['text'].strip()

booru_prompt_text = f"Please convert {response_text} into booru tags for me:"
logger.info("Sending response_text to OpenAI API for booru or danbooru tag conversion...")
response_booru = openai.Completion.create(
    model="gpt-3.5-turbo-instruct",
    prompt=booru_prompt_text,
    max_tokens=300, 
    temperature=0.7
)
logger.info("Received booru tags from OpenAI API.")

booru_tags = response_booru['choices'][0]['text'].strip()

with open("booru_tags.txt", "w") as f:
    f.write(booru_tags)
logger.info("Booru tags saved to booru_tags.txt.")

final_prompt = masterPrompt + yorForgerPrompt + booru_tags

with open("final_prompt.txt", "w") as f:
    f.write(final_prompt)
logger.info("Final prompt saved to final_prompt.txt.")


url_sd = "http://127.0.0.1:7861"
payload_sd = {
    "prompt": final_prompt,
    "steps": 30,
    "negative_prompt": negative_prompt,
    "height": 768,
    "width": 512,
    "sampler_index": "DDIM"
}

logger.info("Sending final prompt to Stable Diffusion API...")
response_sd = requests.post(url=f'{url_sd}/sdapi/v1/txt2img', json=payload_sd)
logger.info("Received response from Stable Diffusion API.")

r_sd = response_sd.json()
image = Image.open(io.BytesIO(base64.b64decode(r_sd['images'][0])))
image.save('output.png')
logger.info("Image saved as output.png.")
